import { flow, pipe } from '../function';
import * as _ from '../internal';
export function fromOption(F) {
    return (onNone) => (ma) => F.fromEither(_.isNone(ma) ? _.left(onNone()) : _.right(ma.value));
}
export function fromPredicate(F) {
    return (predicate) => (b) => F.fromEither(predicate(b) ? _.right(b) : _.left(b));
}
export function fromOptionK(F) {
    const fromOptionF = fromOption(F);
    return (onNone) => {
        const from = fromOptionF(onNone);
        return (f) => flow(f, from);
    };
}
export function chainOptionK(F, M) {
    const fromOptionKF = fromOptionK(F);
    return (onNone) => flow(fromOptionKF(onNone), M.chain);
}
export function fromEitherK(F) {
    return (f) => flow(f, F.fromEither);
}
export function chainEitherK(F, M) {
    return flow(fromEitherK(F), M.chain);
}
export function filterOrElse(F, M) {
    return (predicate, onFalse) => (mb) => pipe(mb, M.chain((a) => F.fromEither(predicate(a) ? _.right(a) : _.left(onFalse(a)))));
}
